/// <summary>
/// Dynamicweb Customer Center Subscriber
/// </summary>
codeunit 50015 DynamicwebCustCenSubscriber
{
    EventSubscriberInstance = StaticAutomatic;

    var
        DynamicwebCustomHelper: Codeunit DynamicwebCustomHelper;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnBeforeExecuteGetPdfForItemRequest', '', true, true)]
    procedure OnBeforeExecuteGetPdfForItemRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var response: BigText);
    var
        xmlRoot: XmlElement;
    begin
        // Modify request xml to your needs
        requestDoc.GetRoot(xmlRoot);
        xmlRoot.Attributes().Set('test', 'value');

        // Set stopExecution to cancel base application processing the request        
        //stopExecution := true;

        // If stopExecution set to true you can set custom response base64 pdf string
        // otherwise base app will return its output        
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnAfterExecuteGetPdfForItemRequest', '', true, true)]
    procedure OnAfterExecuteGetPdfForItemRequest(var requestDoc: XmlDocument; var response: BigText);
    begin
        //you can set custom response base64 pdf string
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnBeforeExecuteGetListRequest', '', true, true)]
    procedure OnBeforeExecuteGetListRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseDoc: XmlDocument);
    begin
        // Modify requestDoc request xml to your needs

        // Set stopExecution := true to cancel base application processing the request        
        // stopExecution := true;

        // If stopExecution set to true you can set custom xml for the response output        
        // otherwise base app will output its content        
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnAfterExecuteGetListRequest', '', true, true)]
    procedure OnAfterExecuteGetListRequest(var requestDoc: XmlDocument; var responseDoc: XmlDocument);
    begin
        // Add custom xml for the response output        
        DynamicwebCustomHelper.AddCustomElement('OnAfterExecuteGetListRequest', responseDoc);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnBeforeExecuteGetItemRequest', '', true, true)]
    procedure OnBeforeExecuteGetItemRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseDoc: XmlDocument);
    begin
        // Modify requestDoc request xml to your needs

        // Set stopExecution := true to cancel base application processing the request        
        // stopExecution := true;

        // If stopExecution set to true you can set custom xml for the response output        
        // otherwise base app will output its content 
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnAfterExecuteGetItemRequest', '', true, true)]
    procedure OnAfterExecuteGetItemRequest(var requestDoc: XmlDocument; var responseDoc: XmlDocument);
    begin
        // Add custom xml for the response output        
        DynamicwebCustomHelper.AddCustomElement('OnAfterExecuteGetItemRequest', responseDoc);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnBeforeExecuteGetCustomerStatementPfRequest', '', true, true)]
    procedure OnBeforeExecuteGetCustomerStatementPfRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var response: BigText);
    var
        xmlRoot: XmlElement;
    begin
        // Modify request xml to your needs
        requestDoc.GetRoot(xmlRoot);
        xmlRoot.Attributes().Set('test', 'value');

        // Set stopExecution to cancel base application processing the request        
        //stopExecution := true;

        // If stopExecution set to true you can set custom response base64 pdf string
        // otherwise base app will return its output   
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebCustomerCenPublisher, 'OnAfterExecuteGetCustomerStatementPfRequest', '', true, true)]
    procedure OnAfterExecuteGetCustomerStatementPfRequest(var requestDoc: XmlDocument; var response: BigText);
    begin
        //you can set custom response base64 pdf string
    end;
}