codeunit 50012 DynamicwebProductsSubscriber
{
    EventSubscriberInstance = StaticAutomatic;

    var
        DynamicwebCustomHelper: Codeunit DynamicwebCustomHelper;

    /// <summary>
    /// Add custom field to the products xml
    /// </summary>
    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAddProductXmlNode', '', true, true)]
    procedure OnAddProductXmlNode(var productNode: XmlNode; item: Record Item);
    var
        attributes: XmlAttributeCollection;
        pXmlElement: XmlElement;
    begin
        pXmlElement := XmlElement.Create('dummy');
        attributes := pXmlElement.Attributes();
        attributes.Set('columnName', 'OnAddProductXmlNode');
        DynamicwebCustomHelper.AddCustomElement('column', 'customValue', attributes, productNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnBeforeGetProductGroupsRequest', '', true, true)]
    procedure OnBeforeGetProductGroupsRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnBeforeGetProductGroupsRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAfterGetProductGroupsRequest', '', true, true)]
    procedure OnAfterGetProductGroupsRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnAfterGetProductGroupsRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnBeforeGetProductStockRequest', '', true, true)]
    procedure OnBeforeGetProductStockRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnBeforeGetProductStockRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAfterGetProductStockRequest', '', true, true)]
    procedure OnAfterGetProductStockRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnAfterGetProductStockRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnBeforeGetProductsRequest', '', true, true)]
    procedure OnBeforeGetProductsRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnBeforeGetProductsRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAfterGetProductsRequest', '', true, true)]
    procedure OnAfterGetProductsRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnAfterGetProductsRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnBeforeGetProductInfoRequest', '', true, true)]
    procedure OnBeforeGetProductInfoRequest(var requestDoc: XmlDocument; var stopExecution: Boolean; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnBeforeGetProductInfoRequest', responseRootNode);
    end;

    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAfterGetProductInfoRequest', '', true, true)]
    procedure OnAfterGetProductInfoRequest(var requestDoc: XmlDocument; var responseRootNode: XmlNode);
    begin
        DynamicwebCustomHelper.AddCustomElement('OnAfterGetProductInfoRequest', responseRootNode);
    end;

    /// <summary>
    /// Add custom field to the product info xml
    /// </summary>
    [EventSubscriber(ObjectType::Codeunit, Codeunit::DynamicwebProductsPublisher, 'OnAddProductInfoXmlNode', '', true, true)]
    procedure OnAddProductInfoXmlNode(var productNode: XmlNode; item: Record Item);
    var
        attributes: XmlAttributeCollection;
        pXmlElement: XmlElement;
    begin
        pXmlElement := XmlElement.Create('dummy');
        attributes := pXmlElement.Attributes();
        attributes.Set('columnName', 'OnAddProductInfoXmlNode');
        DynamicwebCustomHelper.AddCustomElement('column', 'customValue', attributes, productNode);
    end;
}